diff --git a/src/core/dice.c b/src/core/dice.c
index 59b3158..f0ac171 100644
--- a/src/core/dice.c
+++ b/src/core/dice.c
@@ -7,10 +7,10 @@
 #include <string.h>
 #include <rats-tls/err.h>
 #include <rats-tls/log.h>
+#include <internal/dice.h>
 #include <rats-tls/cert.h>
 #include <rats-tls/endorsement.h>
 #include <cbor.h>
-#include "internal/dice.h"
 
 uint64_t tag_of_evidence_type(const char *type)
 {
@@ -26,8 +26,11 @@ uint64_t tag_of_evidence_type(const char *type)
 		return OCBR_TAG_EVIDENCE_SEV;
 	} else if (!strcmp(type, "csv")) {
 		return OCBR_TAG_EVIDENCE_CSV;
+	} else if (!strcmp(type, "virtcca")) {
+		return OCBR_TAG_EVIDENCE_VIRTCCA;
+	} else if (!strcmp(type, "virtcca_fake")) {
+		return OCBR_TAG_EVIDENCE_VIRTCCA;
 	}
-
 	RTLS_FATAL("Unhandled evidence type '%s'\n", type);
 	return 0;
 }
@@ -60,6 +63,12 @@ const uint8_t *evidence_get_raw_as_ref(const attestation_evidence_t *evidence, s
 	} else if (!strcmp(evidence->type, "csv")) {
 		data = (const uint8_t *)&evidence->csv.report;
 		size = evidence->csv.report_len;
+	} else if (!strcmp(evidence->type, "virtcca")) {
+		data = (const uint8_t *)&evidence->virtcca.report;
+		size = evidence->virtcca.report_len;
+	} else if (!strcmp(evidence->type, "virtcca_fake")) {
+		data = (const uint8_t *)&evidence->virtcca.report;
+		size = evidence->virtcca.report_len;
 	} else {
 		RTLS_FATAL("Unhandled evidence type '%s'\n", evidence->type);
 		*size_out = 0;
@@ -67,7 +76,11 @@ const uint8_t *evidence_get_raw_as_ref(const attestation_evidence_t *evidence, s
 	}
 	*size_out = (size_t)size;
 	if (size >= 16)
+		#if 1
+		RTLS_INFO(
+		#else
 		RTLS_DEBUG(
+		#endif
 			"evidence raw data [%zu] %02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x...\n",
 			size, data[0], data[1], data[2], data[3], data[4], data[5], data[6],
 			data[7], data[8], data[9], data[10], data[11], data[12], data[13], data[14],
@@ -79,7 +92,11 @@ int evidence_from_raw(const uint8_t *data, size_t size, uint64_t tag,
 		      attestation_evidence_t *evidence)
 {
 	if (size >= 16)
+		#if 1
+		RTLS_INFO(
+		#else
 		RTLS_DEBUG(
+		#endif
 			"evidence raw data [%zu] %02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x...\n",
 			size, data[0], data[1], data[2], data[3], data[4], data[5], data[6],
 			data[7], data[8], data[9], data[10], data[11], data[12], data[13], data[14],
@@ -147,8 +164,12 @@ int evidence_from_raw(const uint8_t *data, size_t size, uint64_t tag,
 		memcpy(evidence->type, "csv", sizeof("csv"));
 		memcpy((uint8_t *)&evidence->csv.report, data, size);
 		evidence->csv.report_len = size;
+	} else if (tag == OCBR_TAG_EVIDENCE_VIRTCCA) {
+		memcpy(evidence->type, "virtcca", sizeof("virtcca"));
+		memcpy((uint8_t *)&evidence->virtcca.report, data, size);
+		evidence->virtcca.report_len = size;
 	}
-
+	
 	return 0;
 }
 
@@ -201,6 +222,7 @@ err:
 
 enclave_attester_err_t
 dice_generate_claims_buffer(hash_algo_t pubkey_hash_algo, const uint8_t *pubkey_hash,
+				const uint8_t *nonce, size_t nonce_size, 
 			    const claim_t *custom_claims, size_t custom_claims_length,
 			    uint8_t **claims_buffer_out, size_t *claims_buffer_size_out)
 {
@@ -210,9 +232,8 @@ dice_generate_claims_buffer(hash_algo_t pubkey_hash_algo, const uint8_t *pubkey_
 	size_t pubkey_hash_value_buffer_size = 0;
 
 	/* claims-buffer: { "pubkey-hash" : h'<pubkey-hash-value>', "nonce" : h'<nonce-value>'} */
-	/* Note that the nonce is optional, it's for per-session freshness, which we don't support it yet. */
 	ret = ENCLAVE_ATTESTER_ERR_NO_MEM;
-	root = cbor_new_definite_map(1 + custom_claims_length);
+	root = cbor_new_definite_map(2 + custom_claims_length);
 	if (!root)
 		goto err;
 
@@ -233,6 +254,14 @@ dice_generate_claims_buffer(hash_algo_t pubkey_hash_algo, const uint8_t *pubkey_
 	free(pubkey_hash_value_buffer);
 	pubkey_hash_value_buffer = NULL;
 
+	if (!cbor_map_add(root, (struct cbor_pair) {
+					.key = cbor_move(cbor_build_string(CLAIM_NONCE)),
+					.value = cbor_move(cbor_build_bytestring(
+						nonce,
+						nonce_size)) })) {
+		goto err;
+	}
+		
 	/* Add all user-defined claims to map */
 	ret = ENCLAVE_ATTESTER_ERR_NO_MEM;
 	for (size_t i = 0; i < custom_claims_length; i++) {
@@ -710,7 +739,7 @@ err:
 	return ret;
 }
 
-/* Parse the claims buffer and return the custom claims and pubkey hash. Note that
+/* Parse the claims buffer and return the custom claims, pubkey hash, and nonce. Note that
  * the content of the claims buffer is untrusted user input, and its format match
  * the format defined by Interoperable RA-TLS.
  * 
@@ -719,6 +748,8 @@ err:
  * pubkey_hash_algo_out: The `hash_algo_id` of pubkey `hash-entry`
  * pubkey_hash_out: A buffer for writing pubkey hash to, should be large enough
  *     (MAX_HASH_SIZE) to write the hash.
+ * nonce_out: A buffer for write nonce to, should be large enought to write the value.
+ * nonce_size_out: The size of nonce.
  * custom_claims_out: The list of claims stored in the claims buffer, user-defined
  *     custom claims included only. The caller should manage its memory.
  * custom_claims_length_out: The length of claims list.
@@ -726,6 +757,7 @@ err:
 enclave_verifier_err_t
 dice_parse_claims_buffer(const uint8_t *claims_buffer, size_t claims_buffer_size,
 			 hash_algo_t *pubkey_hash_algo_out, uint8_t *pubkey_hash_out,
+			 uint8_t *nonce_out, size_t *nonce_size_out,
 			 claim_t **custom_claims_out, size_t *custom_claims_length_out)
 {
 	enclave_verifier_err_t ret;
@@ -755,6 +787,7 @@ dice_parse_claims_buffer(const uint8_t *claims_buffer, size_t claims_buffer_size
 
 	{
 		bool found_pubkey_hash = false;
+		bool found_nonce = false;
 
 		/* Get claims from claims buffer */
 		claim_t claims[cbor_map_size(root)];
@@ -791,6 +824,19 @@ dice_parse_claims_buffer(const uint8_t *claims_buffer, size_t claims_buffer_size
 				continue;
 			}
 
+			/* Check nonce */
+			if (key_length == sizeof(CLAIM_NONCE) - 1 &&
+			    !strncmp((char *)key_handle, CLAIM_NONCE, key_length)) {
+				found_nonce = true;
+
+				memcpy(nonce_out, value_handle, value_length);
+				*nonce_size_out = value_length;
+
+				/* The "nonce" is a internal claim and should not be returned to the user
+				 * of rats-tls. So we "continue" here. */
+				continue;
+			}
+
 			/* Put user-defined custom claims into the custom_claims list. */
 			claim_t *claim = &claims[count_claims];
 			/* NOTE: The cbor_string_handle(key) returns a non-null terminated string. And the
@@ -824,6 +870,14 @@ dice_parse_claims_buffer(const uint8_t *claims_buffer, size_t claims_buffer_size
 			goto err_claims;
 		}
 
+		if (!found_nonce) {
+			RTLS_ERR(
+				"failed to find claim with name '%s' from claims list with length %zu\n",
+				CLAIM_NONCE, cbor_map_size(root));
+			ret = ENCLAVE_VERIFIER_ERR_INVALID;
+			goto err_claims;
+		}
+
 		custom_claims = malloc(count_claims * sizeof(claim_t));
 		if (!custom_claims) {
 			ret = ENCLAVE_VERIFIER_ERR_NO_MEM;
diff --git a/src/core/main.c b/src/core/main.c
index 88b8af1..24d58c9 100644
--- a/src/core/main.c
+++ b/src/core/main.c
@@ -25,8 +25,6 @@ rtls_core_context_t global_core_context;
 /* The global log level used by log.h */
 rats_tls_log_level_t global_log_level = RATS_TLS_LOG_LEVEL_DEFAULT;
 
-extern rats_tls_log_level_t get_loglevel_env(const char *name);
-
 // clang-format off
 #ifdef SGX
 #define INSTANCE_NUM  (sizeof(enclave_instance_name) / sizeof(enclave_instance_name[0]))
@@ -42,7 +40,7 @@ void __attribute__((constructor)) librats_tls_init(void)
 {
 	RTLS_DEBUG("called\n");
 
-	global_log_level = get_loglevel_env("RATS_TLS_GLOBAL_LOG_LEVEL");
+	global_log_level = rtls_loglevel_getenv("RATS_TLS_GLOBAL_LOG_LEVEL");
 	if (global_log_level == (rats_tls_log_level_t)-1) {
 		RTLS_FATAL("failed to get log level from env\n");
 		rtls_exit();
diff --git a/src/core/rtls_common.c b/src/core/rtls_common.c
index 7c77600..891f0d8 100644
--- a/src/core/rtls_common.c
+++ b/src/core/rtls_common.c
@@ -41,35 +41,41 @@ void rtls_exit(void)
 	ocall_exit();
 }
 
-rats_tls_log_level_t get_loglevel_env(const char *name)
+rats_tls_log_level_t rtls_loglevel_getenv(const char *name)
 {
-	size_t log_level_len = 8;
+	char *log_level_str = NULL;
+	size_t log_level_len = 32;
 
-	char *log_level_str = calloc(1, log_level_len);
+	log_level_str = calloc(1, log_level_len);
 	if (!log_level_str) {
 		RTLS_ERR("failed to calloc log level string\n");
 		return -1;
 	}
 
 	ocall_getenv(name, log_level_str, log_level_len);
+	if (log_level_str) {
+		if (!strcmp(log_level_str, "debug") || !strcmp(log_level_str, "DEBUG")) {
+			free(log_level_str);
+			return RATS_TLS_LOG_LEVEL_DEBUG;
+		} else if (!strcmp(log_level_str, "info") || !strcmp(log_level_str, "INFO")) {
+			free(log_level_str);
+			return RATS_TLS_LOG_LEVEL_INFO;
+		} else if (!strcmp(log_level_str, "warn") || !strcmp(log_level_str, "WARN")) {
+			free(log_level_str);
+			return RATS_TLS_LOG_LEVEL_WARN;
+		} else if (!strcmp(log_level_str, "error") || !strcmp(log_level_str, "ERROR")) {
+			free(log_level_str);
+			return RATS_TLS_LOG_LEVEL_ERROR;
+		} else if (!strcmp(log_level_str, "fatal") || !strcmp(log_level_str, "FATAL")) {
+			free(log_level_str);
+			return RATS_TLS_LOG_LEVEL_FATAL;
+		} else if (!strcmp(log_level_str, "off") || !strcmp(log_level_str, "OFF")) {
+			free(log_level_str);
+			return RATS_TLS_LOG_LEVEL_NONE;
+		}
+	}
 
-	rats_tls_log_level_t level = RATS_TLS_LOG_LEVEL_DEFAULT;
-	if (!strcmp(log_level_str, "debug") || !strcmp(log_level_str, "DEBUG"))
-		level = RATS_TLS_LOG_LEVEL_DEBUG;
-	else if (!strcmp(log_level_str, "info") || !strcmp(log_level_str, "INFO"))
-		level = RATS_TLS_LOG_LEVEL_INFO;
-	else if (!strcmp(log_level_str, "warn") || !strcmp(log_level_str, "WARN"))
-		level = RATS_TLS_LOG_LEVEL_WARN;
-	else if (!strcmp(log_level_str, "error") || !strcmp(log_level_str, "ERROR"))
-		level = RATS_TLS_LOG_LEVEL_ERROR;
-	else if (!strcmp(log_level_str, "fatal") || !strcmp(log_level_str, "FATAL"))
-		level = RATS_TLS_LOG_LEVEL_FATAL;
-	else if (!strcmp(log_level_str, "off") || !strcmp(log_level_str, "OFF"))
-		level = RATS_TLS_LOG_LEVEL_NONE;
-
-	free(log_level_str);
-
-	return level;
+	return RATS_TLS_LOG_LEVEL_DEFAULT;
 }
 
 rats_tls_err_t rtls_instance_init(const char *name, __attribute__((unused)) const char *realpath,
@@ -197,25 +203,23 @@ void rtls_exit(void)
 	exit(EXIT_FAILURE);
 }
 
-rats_tls_log_level_t get_loglevel_env(const char *name)
+rats_tls_log_level_t rtls_loglevel_getenv(const char *name)
 {
-	char *log_level_str = getenv(name);
-
-	if (!log_level_str)
-		return RATS_TLS_LOG_LEVEL_DEFAULT;
-
-	if (!strcasecmp(log_level_str, "debug"))
-		return RATS_TLS_LOG_LEVEL_DEBUG;
-	else if (!strcasecmp(log_level_str, "info"))
-		return RATS_TLS_LOG_LEVEL_INFO;
-	else if (!strcasecmp(log_level_str, "warn"))
-		return RATS_TLS_LOG_LEVEL_WARN;
-	else if (!strcasecmp(log_level_str, "error"))
-		return RATS_TLS_LOG_LEVEL_ERROR;
-	else if (!strcasecmp(log_level_str, "fatal"))
-		return RATS_TLS_LOG_LEVEL_FATAL;
-	else if (!strcasecmp(log_level_str, "off"))
-		return RATS_TLS_LOG_LEVEL_NONE;
+	char *log_level_str = log_level_str = getenv(name);
+	if (log_level_str) {
+		if (!strcasecmp(log_level_str, "debug"))
+			return RATS_TLS_LOG_LEVEL_DEBUG;
+		else if (!strcasecmp(log_level_str, "info"))
+			return RATS_TLS_LOG_LEVEL_INFO;
+		else if (!strcasecmp(log_level_str, "warn"))
+			return RATS_TLS_LOG_LEVEL_WARN;
+		else if (!strcasecmp(log_level_str, "error"))
+			return RATS_TLS_LOG_LEVEL_ERROR;
+		else if (!strcasecmp(log_level_str, "fatal"))
+			return RATS_TLS_LOG_LEVEL_FATAL;
+		else if (!strcasecmp(log_level_str, "off"))
+			return RATS_TLS_LOG_LEVEL_NONE;
+	}
 
 	return RATS_TLS_LOG_LEVEL_DEFAULT;
 }
diff --git a/src/core/rtls_core_generate_certificate.c b/src/core/rtls_core_generate_certificate.c
index b20db41..a4aa2c8 100644
--- a/src/core/rtls_core_generate_certificate.c
+++ b/src/core/rtls_core_generate_certificate.c
@@ -10,6 +10,7 @@
 #include "internal/attester.h"
 #include "internal/verifier.h"
 #include "internal/dice.h"
+#include "rats-tls/nonce.h"
 #include <string.h>
 
 rats_tls_err_t rtls_core_generate_certificate(rtls_core_context_t *ctx)
@@ -21,10 +22,6 @@ rats_tls_err_t rtls_core_generate_certificate(rtls_core_context_t *ctx)
 	    !ctx->crypto_wrapper->opts->gen_cert)
 		return -RATS_TLS_ERR_INVALID;
 
-	/* Avoid re-generation of TLS certificates */
-	if (ctx->flags & RATS_TLS_CTX_FLAGS_CERT_CREATED)
-		return RATS_TLS_ERR_NONE;
-
 	/* Check whether the specified algorithm is supported.
 	 *
 	 * TODO: the supported algorithm list should be provided by a crypto
@@ -59,6 +56,15 @@ rats_tls_err_t rtls_core_generate_certificate(rtls_core_context_t *ctx)
 	if (c_err != CRYPTO_WRAPPER_ERR_NONE)
 		return c_err;
 
+	/* Get received nonce */
+	uint8_t nonce[MAX_NONCE_SIZE];
+	size_t nonce_size = sizeof(nonce);
+	tls_wrapper_err_t t_err;
+	t_err = ctx->tls_wrapper->opts->get_nonce(ctx->tls_wrapper, true, nonce, &nonce_size);
+	if (t_err != TLS_WRAPPER_ERR_NONE) {
+		return t_err;
+	}
+
 	/* Collect evidence */
 	attestation_evidence_t evidence;
 	memset(&evidence, 0, sizeof(attestation_evidence_t));
@@ -71,7 +77,7 @@ rats_tls_err_t rtls_core_generate_certificate(rtls_core_context_t *ctx)
 	RTLS_DEBUG("fill evidence user-data field with sha256 of claims_buffer\n");
 	/* Generate claims_buffer */
 	enclave_attester_err_t a_ret = dice_generate_claims_buffer(
-		HASH_ALGO_SHA256, hash, ctx->config.custom_claims, ctx->config.custom_claims_length,
+		HASH_ALGO_SHA256, hash, nonce, nonce_size, ctx->config.custom_claims, ctx->config.custom_claims_length,
 		&claims_buffer, &claims_buffer_size);
 	if (a_ret != ENCLAVE_ATTESTER_ERR_NONE) {
 		RTLS_DEBUG("generate claims_buffer failed. a_ret: %#x\n", a_ret);
@@ -110,13 +116,13 @@ rats_tls_err_t rtls_core_generate_certificate(rtls_core_context_t *ctx)
 		.endorsements_buffer_size = 0,
 	};
 
-	/* Get DICE evidence buffer.
-	 * This check is a workaround for the nullattester.
-	 * Note: For nullattester, we do not generate an evidence_buffer, nor do we generate evidence extension.
-	 */
-	if (evidence.type[0] == '\0')
-		RTLS_WARN("No evidence in certificate due to using nullattester\n");
-	else {
+	/* Get DICE evidence buffer */
+	/* This check is a workaround for the nullattester.
+	 * Note: For nullattester, we do not generate an evidence_buffer. nor do we generate evidence extension.  */
+	if (evidence.type[0] == '\0') {
+		RTLS_WARN(
+			"evidence type is empty, which is normal only when you are using nullattester.\n");
+	} else {
 		enclave_attester_err_t d_ret = dice_generate_evidence_buffer_with_tag(
 			&evidence, claims_buffer, claims_buffer_size, &cert_info.evidence_buffer,
 			&cert_info.evidence_buffer_size);
@@ -191,8 +197,5 @@ rats_tls_err_t rtls_core_generate_certificate(rtls_core_context_t *ctx)
 	if (cert_info.cert_buf)
 		free(cert_info.cert_buf);
 
-	/* Prevent from re-generation of TLS certificate */
-	ctx->flags |= RATS_TLS_CTX_FLAGS_CERT_CREATED;
-
 	return RATS_TLS_ERR_NONE;
 }
diff --git a/src/crypto_wrappers/internal/rtls_crypto_wrapper_load_all.c b/src/crypto_wrappers/internal/rtls_crypto_wrapper_load_all.c
index 0e805bb..450e958 100644
--- a/src/crypto_wrappers/internal/rtls_crypto_wrapper_load_all.c
+++ b/src/crypto_wrappers/internal/rtls_crypto_wrapper_load_all.c
@@ -42,23 +42,21 @@ rats_tls_err_t rtls_crypto_wrapper_load_all(void)
 	unsigned int total_loaded = 0;
 	rtls_dirent *ptr = NULL;
 	while (rtls_readdir(dir, &ptr) != 1) {
-		const char *d_name = ptr->d_name;
-
-		if (!strcmp(d_name, ".") || !strcmp(d_name, ".."))
+		if (!strcmp(ptr->d_name, ".") || !strcmp(ptr->d_name, "..")) {
 			continue;
-
-		if (strncmp(d_name + strlen(d_name) - strlen(PATTERN_SUFFIX), PATTERN_SUFFIX,
-			    strlen(PATTERN_SUFFIX)))
+		}
+		if (strncmp(ptr->d_name + strlen(ptr->d_name) - strlen(PATTERN_SUFFIX),
+			    PATTERN_SUFFIX, strlen(PATTERN_SUFFIX))) {
 			continue;
-
+		}
 #ifdef OCCLUM
 		/* Occlum can't identify the d_type of the file, always return DT_UNKNOWN */
-		if (strncmp(d_name + strlen(d_name) - strlen(PATTERN_SUFFIX), PATTERN_SUFFIX,
-			    strlen(PATTERN_SUFFIX)) == 0) {
+		if (strncmp(ptr->d_name + strlen(ptr->d_name) - strlen(PATTERN_SUFFIX),
+			    PATTERN_SUFFIX, strlen(PATTERN_SUFFIX)) == 0) {
 #else
 		if (ptr->d_type == DT_REG || ptr->d_type == DT_LNK) {
 #endif
-			if (rtls_crypto_wrapper_load_single(d_name) == RATS_TLS_ERR_NONE)
+			if (rtls_crypto_wrapper_load_single(ptr->d_name) == RATS_TLS_ERR_NONE)
 				++total_loaded;
 		}
 	}
diff --git a/src/include/internal/attester.h b/src/include/internal/attester.h
index 78ee0c6..8be2a6e 100644
--- a/src/include/internal/attester.h
+++ b/src/include/internal/attester.h
@@ -10,7 +10,9 @@
 #include <rats-tls/attester.h>
 #include "internal/core.h"
 
+#ifndef ENCLAVE_ATTESTERS_DIR
 #define ENCLAVE_ATTESTERS_DIR "/usr/local/lib/rats-tls/attesters/"
+#endif
 
 extern rats_tls_err_t rtls_enclave_attester_load_all(void);
 extern rats_tls_err_t rtls_enclave_attester_load_single(const char *);
diff --git a/src/include/internal/core.h b/src/include/internal/core.h
index 0edb573..4697968 100644
--- a/src/include/internal/core.h
+++ b/src/include/internal/core.h
@@ -41,6 +41,8 @@ extern rats_tls_err_t rtls_core_generate_certificate(rtls_core_context_t *);
 
 extern void rtls_exit(void);
 
+extern rats_tls_log_level_t rtls_loglevel_getenv(const char *name);
+
 extern rats_tls_err_t rtls_instance_init(const char *type, const char *realpath, void **handle);
 
 extern ssize_t rtls_write(int fd, const void *buf, size_t count);
diff --git a/src/include/internal/cpu.h b/src/include/internal/cpu.h
index 8bfebc2..0a21fc9 100644
--- a/src/include/internal/cpu.h
+++ b/src/include/internal/cpu.h
@@ -28,5 +28,6 @@ extern bool is_tdguest_supported(void);
 extern bool is_snpguest_supported(void);
 extern bool is_sevguest_supported(void);
 extern bool is_csvguest_supported(void);
+extern bool is_virtccaguest_supported(void);
 
 #endif /* _INTERNAL_CPU_H */
diff --git a/src/include/internal/crypto_wrapper.h b/src/include/internal/crypto_wrapper.h
index c155f4a..3f17d9b 100644
--- a/src/include/internal/crypto_wrapper.h
+++ b/src/include/internal/crypto_wrapper.h
@@ -10,7 +10,9 @@
 #include <rats-tls/crypto_wrapper.h>
 #include "internal/core.h"
 
+#ifndef CRYPTO_WRAPPERS_DIR
 #define CRYPTO_WRAPPERS_DIR "/usr/local/lib/rats-tls/crypto-wrappers/"
+#endif
 
 extern rats_tls_err_t rtls_crypto_wrapper_load_all(void);
 extern rats_tls_err_t rtls_crypto_wrapper_load_single(const char *);
diff --git a/src/include/internal/tls_wrapper.h b/src/include/internal/tls_wrapper.h
index b5e2f94..3758cfd 100644
--- a/src/include/internal/tls_wrapper.h
+++ b/src/include/internal/tls_wrapper.h
@@ -10,7 +10,9 @@
 #include <rats-tls/tls_wrapper.h>
 #include "internal/core.h"
 
+#ifndef TLS_WRAPPERS_DIR
 #define TLS_WRAPPERS_DIR "/usr/local/lib/rats-tls/tls-wrappers/"
+#endif
 
 extern rats_tls_err_t rtls_tls_wrapper_load_all(void);
 extern rats_tls_err_t rtls_tls_wrapper_load_single(const char *);
diff --git a/src/include/internal/verifier.h b/src/include/internal/verifier.h
index 659e689..a2f99f7 100644
--- a/src/include/internal/verifier.h
+++ b/src/include/internal/verifier.h
@@ -10,7 +10,9 @@
 #include <rats-tls/verifier.h>
 #include "internal/core.h"
 
+#ifndef ENCLAVE_VERIFIERS_DIR
 #define ENCLAVE_VERIFIERS_DIR "/usr/local/lib/rats-tls/verifiers/"
+#endif
 
 extern rats_tls_err_t rtls_enclave_verifier_load_all(void);
 extern rats_tls_err_t rtls_enclave_verifier_load_single(const char *);
diff --git a/src/include/rats-tls/api.h b/src/include/rats-tls/api.h
index 557872a..8fbb0e2 100644
--- a/src/include/rats-tls/api.h
+++ b/src/include/rats-tls/api.h
@@ -100,6 +100,11 @@ typedef struct rtls_csv_evidence {
 	uint32_t policy_sz;
 } rtls_csv_evidence_t;
 
+typedef struct rtls_cca_evidence {
+	uint8_t *evidence;
+	uint32_t evidence_sz;
+} rtls_cca_evidence_t;
+
 /* The public_key, user_data_size and user_data are needed to include in hash. */
 typedef struct ehd {
 	void *public_key;
@@ -109,7 +114,7 @@ typedef struct ehd {
 	char *unhashed;
 } ehd_t;
 
-typedef enum { SGX_ECDSA = 1, TDX_ECDSA, CSV } enclave_evidence_type_t;
+typedef enum { SGX_ECDSA = 1, TDX_ECDSA, CSV, CCA } enclave_evidence_type_t;
 
 typedef struct rtls_evidence {
 	enclave_evidence_type_t type;
@@ -122,6 +127,7 @@ typedef struct rtls_evidence {
 		rtls_sgx_evidence_t sgx;
 		rtls_tdx_evidence_t tdx;
 		rtls_csv_evidence_t csv;
+		rtls_cca_evidence_t cca;
 	};
 } rtls_evidence_t;
 
diff --git a/src/include/rats-tls/attester.h b/src/include/rats-tls/attester.h
index e73472a..1bd96c7 100644
--- a/src/include/rats-tls/attester.h
+++ b/src/include/rats-tls/attester.h
@@ -20,11 +20,13 @@
 #define ENCLAVE_ATTESTER_API_VERSION_MAX     ENCLAVE_ATTESTER_API_VERSION_1
 #define ENCLAVE_ATTESTER_API_VERSION_DEFAULT ENCLAVE_ATTESTER_API_VERSION_1
 
-#define ENCLAVE_ATTESTER_OPTS_FLAGS_SGX_ENCLAVE (1 << 0)
-#define ENCLAVE_ATTESTER_OPTS_FLAGS_TDX_GUEST	(ENCLAVE_ATTESTER_OPTS_FLAGS_SGX_ENCLAVE << 1)
-#define ENCLAVE_ATTESTER_OPTS_FLAGS_SEV_GUEST	(ENCLAVE_ATTESTER_OPTS_FLAGS_TDX_GUEST << 1)
-#define ENCLAVE_ATTESTER_OPTS_FLAGS_SNP_GUEST	(ENCLAVE_ATTESTER_OPTS_FLAGS_SEV_GUEST << 1)
-#define ENCLAVE_ATTESTER_OPTS_FLAGS_CSV_GUEST	(ENCLAVE_ATTESTER_OPTS_FLAGS_SNP_GUEST << 1)
+#define ENCLAVE_ATTESTER_OPTS_FLAGS_SGX_ENCLAVE 	(1 << 0)
+#define ENCLAVE_ATTESTER_OPTS_FLAGS_TDX_GUEST		(ENCLAVE_ATTESTER_OPTS_FLAGS_SGX_ENCLAVE << 1)
+#define ENCLAVE_ATTESTER_OPTS_FLAGS_SEV_GUEST		(ENCLAVE_ATTESTER_OPTS_FLAGS_TDX_GUEST << 1)
+#define ENCLAVE_ATTESTER_OPTS_FLAGS_SNP_GUEST		(ENCLAVE_ATTESTER_OPTS_FLAGS_SEV_GUEST << 1)
+#define ENCLAVE_ATTESTER_OPTS_FLAGS_CSV_GUEST		(ENCLAVE_ATTESTER_OPTS_FLAGS_SNP_GUEST << 1)
+#define ENCLAVE_ATTESTER_OPTS_FLAGS_VIRTCCA_GUEST	(ENCLAVE_ATTESTER_OPTS_FLAGS_CSV_GUEST << 1)
+#define ENCLAVE_ATTESTER_OPTS_FLAGS_VIRTCCA_FAKE	(ENCLAVE_ATTESTER_OPTS_FLAGS_VIRTCCA_GUEST << 1)
 
 #define ENCLAVE_ATTESTER_FLAGS_DEFAULT 0
 
@@ -78,6 +80,12 @@ struct enclave_attester_ctx {
 			const char name[ENCLAVE_ATTESTER_TYPE_NAME_SIZE];
 			uint8_t cert_type;
 		} tdx;
+
+		struct {
+			const char name[ENCLAVE_ATTESTER_TYPE_NAME_SIZE];
+			// Fixme: Add here
+		} virtcca;
+		
 	} config;
 };
 
diff --git a/src/include/rats-tls/cert.h b/src/include/rats-tls/cert.h
index 2706696..d59b478 100644
--- a/src/include/rats-tls/cert.h
+++ b/src/include/rats-tls/cert.h
@@ -7,6 +7,8 @@
 #ifndef _ENCLAVE_CERT_H
 #define _ENCLAVE_CERT_H
 
+#define REPORT_MAX_LENGTH 8192
+
 typedef struct {
 	const unsigned char *organization;
 	const unsigned char *organization_unit;
@@ -54,6 +56,11 @@ typedef struct {
 	uint32_t report_len;
 } csv_attestation_evidence_t;
 
+typedef struct {
+	uint8_t report[REPORT_MAX_LENGTH];  // 8bytes report_len + report + 8bytes device_cert_len + device_cert
+	uint32_t report_len;
+} virtcca_attestation_evidence_t;
+
 typedef struct {
 	char type[ENCLAVE_ATTESTER_TYPE_NAME_SIZE];
 	union {
@@ -64,6 +71,7 @@ typedef struct {
 		snp_attestation_evidence_t snp;
 		sev_attestation_evidence_t sev;
 		csv_attestation_evidence_t csv;
+		virtcca_attestation_evidence_t virtcca;
 	};
 } attestation_evidence_t;
 
diff --git a/src/include/rats-tls/err.h b/src/include/rats-tls/err.h
index 359e8eb..c01c8ed 100644
--- a/src/include/rats-tls/err.h
+++ b/src/include/rats-tls/err.h
@@ -116,6 +116,7 @@ typedef enum {
 	TLS_WRAPPER_ERR_UNSUPPORTED_QUOTE,
 	TLS_WRAPPER_ERR_PRIV_KEY,
 	TLS_WRAPPER_ERR_CERT,
+	TLS_WRAPPER_ERR_NONCE,
 	TLS_WRAPPER_ERR_UNKNOWN,
 } tls_wrapper_err_t;
 
diff --git a/src/include/rats-tls/log.h b/src/include/rats-tls/log.h
index 9edb201..6895b50 100644
--- a/src/include/rats-tls/log.h
+++ b/src/include/rats-tls/log.h
@@ -61,6 +61,14 @@ extern rats_tls_log_level_t global_log_level;
 			printf("[" #level "] %s()@L%d: " fmt, __FUNCTION__, __LINE__, \
 			       ##__VA_ARGS__);                                        \
 	} while (0)
+#elif defined VIRTCCA
+  #define __PR__(level, io, fmt, ...)                                                   \
+	do {                                                                          \
+		if (global_log_level <= RATS_TLS_LOG_LEVEL_##level)               \
+			printf("[" #level "] %s()@L%d: " fmt, __FUNCTION__, __LINE__, \
+			       ##__VA_ARGS__);                                        \
+			fflush(io); 												  \
+	} while (0)
 #else
   #define __PR__(level, io, fmt, ...)                                                   \
 	do {                                                                            \
diff --git a/src/include/rats-tls/nonce.h b/src/include/rats-tls/nonce.h
new file mode 100644
index 0000000..82c2999
--- /dev/null
+++ b/src/include/rats-tls/nonce.h
@@ -0,0 +1,6 @@
+#ifndef _RATS_TLS_NONCE_H
+#define _RATS_TLS_NONCE_H
+
+#define MAX_NONCE_SIZE 64
+
+#endif /* _RATS_TLS_NONCE_H */
\ No newline at end of file
diff --git a/src/include/rats-tls/tls_wrapper.h b/src/include/rats-tls/tls_wrapper.h
index 32ad442..5e7d42d 100644
--- a/src/include/rats-tls/tls_wrapper.h
+++ b/src/include/rats-tls/tls_wrapper.h
@@ -36,6 +36,7 @@ typedef struct {
 	tls_wrapper_err_t (*use_privkey)(tls_wrapper_ctx_t *ctx, rats_tls_cert_algo_t algo,
 					 void *privkey_buf, size_t privkey_len);
 	tls_wrapper_err_t (*use_cert)(tls_wrapper_ctx_t *ctx, rats_tls_cert_info_t *cert_info);
+	tls_wrapper_err_t (*get_nonce)(tls_wrapper_ctx_t *ctx, bool peer, void *buf, size_t *buf_size);
 	tls_wrapper_err_t (*negotiate)(tls_wrapper_ctx_t *ctx, int fd);
 	tls_wrapper_err_t (*transmit)(tls_wrapper_ctx_t *ctx, void *buf, size_t *buf_size);
 	tls_wrapper_err_t (*receive)(tls_wrapper_ctx_t *ctx, void *buf, size_t *buf_size);
@@ -57,7 +58,8 @@ extern tls_wrapper_err_t tls_wrapper_register(const tls_wrapper_opts_t *);
 
 extern tls_wrapper_err_t
 tls_wrapper_verify_certificate_extension(tls_wrapper_ctx_t *tls_ctx, const uint8_t *pubkey_buffer,
-					 size_t pubkey_buffer_size, uint8_t *evidence_buffer,
+					 size_t pubkey_buffer_size, const uint8_t *nonce_buffer,
+					 size_t nonce_buffer_size, uint8_t *evidence_buffer,
 					 size_t evidence_buffer_size, uint8_t *endorsements_buffer,
 					 size_t endorsements_buffer_size);
 
diff --git a/src/include/rats-tls/verifier.h b/src/include/rats-tls/verifier.h
index be891e9..4041841 100644
--- a/src/include/rats-tls/verifier.h
+++ b/src/include/rats-tls/verifier.h
@@ -23,10 +23,11 @@
 #define ENCLAVE_VERIFIER_OPTS_FLAGS_DEFAULT	 0
 #define ENCLAVE_VERIFIER_OPTS_FLAGS_SGX1_ENCLAVE (1 << 0)
 #define ENCLAVE_VERIFIER_OPTS_FLAGS_SGX2_ENCLAVE (1 << 1)
-#define ENCLAVE_VERIFIER_OPTS_FLAGS_TDX		 (1 << 2)
-#define ENCLAVE_VERIFIER_OPTS_FLAGS_SNP		 (1 << 3)
-#define ENCLAVE_VERIFIER_OPTS_FLAGS_SEV		 (1 << 4)
-#define ENCLAVE_VERIFIER_OPTS_FLAGS_CSV		 (1 << 5)
+#define ENCLAVE_VERIFIER_OPTS_FLAGS_TDX		 	 (1 << 2)
+#define ENCLAVE_VERIFIER_OPTS_FLAGS_SNP		 	 (1 << 3)
+#define ENCLAVE_VERIFIER_OPTS_FLAGS_SEV		 	 (1 << 4)
+#define ENCLAVE_VERIFIER_OPTS_FLAGS_CSV		 	 (1 << 5)
+#define ENCLAVE_VERIFIER_OPTS_FLAGS_VIRTCCA		 (1 << 6)
 
 typedef struct enclave_verifier_ctx enclave_verifier_ctx_t;
 
@@ -72,6 +73,11 @@ struct enclave_verifier_ctx {
 			const char name[ENCLAVE_VERIFIER_TYPE_NAME_SIZE];
 			uint8_t cert_type;
 		} tdx;
+
+		struct {
+			const char name[ENCLAVE_VERIFIER_TYPE_NAME_SIZE];
+			// FixMe: add here
+		} virtcca;
 	} config;
 };
 
